using System;
using System.Collections.Generic;
using System.Linq;
using System.Windows.Input;
using GalaSoft.MvvmLight;
using GalaSoft.MvvmLight.CommandWpf;

namespace WpfNavigation.ViewModel
{
    public class MainViewModel : ViewModelBase
    {
        private RelayCommand<AViewModel> _changePageCommand;
        private AViewModel _currentPageViewModel;

        private List<AViewModel> _viewModelList = new List<AViewModel>();

        public List<AViewModel> ViewModelList
        {
            get
            {
                return _viewModelList;
            }
        }

        public AViewModel CurrentPageViewModel
        {
            get
            {
                return _currentPageViewModel;
            }
            set
            {
                Set(() => CurrentPageViewModel, ref _currentPageViewModel, value);
            }
        }

        public RelayCommand<AViewModel> ChangePageCommand { get; private set; }   

        public MainViewModel()
        {
            ChangePageCommand = new RelayCommand<AViewModel>(p => ChangePageAction(p));

            _viewModelList.Add(ViewModelLocator.Instance.View1);
            _viewModelList.Add(ViewModelLocator.Instance.View2);
            _viewModelList.Add(ViewModelLocator.Instance.View3);

            _currentPageViewModel = _viewModelList[0];
        }

        private void ChangePageAction(AViewModel viewModel)
        {
            CurrentPageViewModel = ViewModelList.FirstOrDefault(vm => vm == viewModel);
        }
    }
}